<?php
/*
Plugin Name: Blog Mechanics Keyword Link
Plugin URI: http://www.dijksterhuis.org/wordpress-plugins/keyword-link-plugin/
Description: A little plugin that helps to automatically link defined keywords to certain articles.<a href="http://www.juyimeng.com">phpbird</a>修改不支持中文的问题     
Author: Martijn Dijksterhuis
Version: 0.4.1
Author URI: http://www.dijksterhuis.org/#
*/

/* The idea for this plugin comes from a website I designed. It has lots of touristic 
 * information and it would be great if every important keyword would automatically be linked
 * to its relevant articles instead of me having to do this by hand.  
 *
 * Example:  "A visit to the UK is not complete without a visit to stonehenge."
 *
 * Would become:  "A visit to the UK is not complete without a visit to <A href="link">stonehenge</a>."
*/

/* Constants */
define(BM_KEYWORDLINK_OPTION,'bm_keywordlinkoption');

/* If you would like to change only the first occurance of a term, as opposed to all
 * occurances, please change the following to "TRUE"
*/

function bm_keywordlink_admininit()
{
	 // Add a page to the options section of the website
   if (current_user_can('manage_options')) 				
 		add_options_page("BM Keywordlink","BM Keywordlink", 8, __FILE__, 'bm_keywordlink_optionpage');
}

function bm_keywordlink_topbarmessage($msg)
{
	 echo '<div class="updated fade" id="message"><p>' . $msg . '</p></div>';
}

function bm_keywordlink_showdefinitions()
{
 		 /* Retrieve the keyword definitions */ 
		 $links = get_option(BM_KEYWORDLINK_OPTION);

		 echo "<h3>Links</h3>";
		 
		 if ($links)
		 { 
  		 echo "<table class='widefat'>\n";		 	  
 	     echo "<thead><tr><th>#</th><th>Keyword</th><th>Link</th><th>Attributes</th><th>Action</th></tr></thead>\n";
			 $cnt = 0;
		 	 foreach ($links as $keyword => $details) 
		 	 {
				list($link,$nofollow,$firstonly,$newwindow,$ignorecase) = explode('|',$details);		 	 
		 	 
			   if ($cnt++ % 2) echo '<tr class=alternate>'; else echo '<tr>';
				 echo "<td>$cnt</td><td>$keyword</td><td><a href='$link'>$link</a></td>";
				 
				/* show attributes */
				echo "<td>";				 
				if ($nofollow) echo "[nofollow] ";
				if ($firstonly) echo "[first only] ";
				if ($newwindow) echo "[new window] ";
				if ($ignorecase) echo "[ignore case] ";				
				echo "</td>";				 
				 
				echo "<td><input type=button value=Delete onClick='javascript:BMDeleteKeyword(\"$keyword\");' /></td></tr>";
		 	 }
			 echo "</table>";
		 }
		 else
		 	 echo "<p>No links have been defined!</p>";
			 
		?>
		
		<!-- Support for the delete button , we use Javascript here -->
		<form name=delete_form method="post" action="">
		 <input type=hidden name=action value=delete />
		 <input type=hidden name=keyword value="" />
		</form>
		<script type="text/javascript">
		
		function BMDeleteKeyword(keyword)
		{
		   if (confirm('Are you sure you want to delete this keyword?'))
			 {
			   document.delete_form.keyword.value = keyword; 
			   document.delete_form.submit();
			 }
		} 
		</script>
		<?php	 
			 

}

function bm_keywordlink_addnew()
{
 		echo '<h3>Add a new link</h3>';
		echo '<form name=bm_keywordadd method="post" action="">';
		echo '<input type=hidden name=action value=save />';
		echo '<table>';
		echo '<tr>';
		echo '<td><label for=keyword>Keyword</label></td><td><input type=text name=keyword /></td></tr>';
		echo '<tr><td><label for=link>Link</label></td><td><input type=text size=50 maxlength=200 name=link /></td></tr>';
		echo '<tr><td><label for=nofollow>No Follow</label></td><td><input type=checkbox name=nofollow value="nofollow">';
		echo '/ <label for=firstonly>First Match Only</label>&nbsp;<input type=checkbox name=firstonly value="firstonly">';
		echo '/ <label for=newwindow>New Window</label>&nbsp;<input type=checkbox name=newwindow value="newwindow">';
		echo '/ <label for=ignorecase>Ignore case</label>&nbsp;<input type=checkbox name=ignorecase value="ignorecase">';
		echo '</td></tr>';
		echo '<tr><td><input type=submit value="Save" /></td></tr></table>';
		echo '</form>'; 
}

function bm_keywordlink_savenew()
{
    $links = get_option(BM_KEYWORDLINK_OPTION);
		
		$keyword = $_POST['keyword'];
		$link = $_POST['link'];
		$nofollow = $_POST['nofollow'];
 		$firstonly = $_POST['firstonly'];
 		$newwindow = $_POST['newwindow'];
 		$ignorecase = $_POST['ignorecase']; 
		
		if ($keyword == '' || $link == '')
		{
		  bm_keywordlink_topbarmessage(__('Please enter both a keyword and URL'));
			return;     		  
		}
		
		if (isset($links[$keyword]))
		{
		  bm_keywordlink_topbarmessage(__('This keyword already has an entry, no duplicates please!'));
			return;     		  
		}
 
 		/* Store the link */ 
	  $links[$keyword] = implode('|',array($link,$nofollow,$firstonly,$newwindow,$ignorecase));
	  update_option(BM_KEYWORDLINK_OPTION,$links);      
}

function bm_keywordlink_deletekeyword()
{
		$links = get_option(BM_KEYWORDLINK_OPTION);
    $keyword = $_POST['keyword'];
		
		if (!isset($links[$keyword]))
		{
		  bm_keywordlink_topbarmessage(__('No such keyword, bizarre error!'));
			return;     		  
		}

		unset($links[$keyword]);
		update_option(BM_KEYWORDLINK_OPTION,$links);
} 


function bm_keywordlink_optionpage()
{
    /* Perform any action */
		if ($_POST['action']=='save')
		 bm_keywordlink_savenew(); 

		if ($_POST['action']=='delete')
		 bm_keywordlink_deletekeyword(); 
		
		/* Definition */
      echo '<div class="wrap">';
		echo '<h2>BlogMechanics KeywordLink</h2>';

		/* Introduction */ 
		echo '<p>This plugin automatically links keywords in your posts to their definition pages.</p>';

		/* Show the existing options */
		bm_keywordlink_showdefinitions();
		
		/* Allow adding a new link */ 
		bm_keywordlink_addnew(); 		

		echo '</div>';
}

/* bm_keywordlink_replace
 *
 * This is where everything happens... search the content and search for our set of keywords
 * and add the links in the right places. 
*/

function bm_keywordlink_replace($content)
{
    $links = get_option(BM_KEYWORDLINK_OPTION);

    if ($links)
	 	 foreach ($links as $keyword => $details)
		 {
			   list($link,$nofollow,$firstonly,$newwindow,$ignorecase) = explode("|",$details);		 
		 
		 	   $url  = "<span class='bm_keywordlink'>";
		 	   $url .= "<a href='$link'";

				if ($nofollow) $url .= ' rel="nofollow"';
				if ($newwindow) $url .= ' target="_blank"';
		 	   
		 	   $url .= ">$keyword</a>";
		 	   $url .= "</span>";
		 	   
				if ($firstonly) $limit = 1; else $limit=-1;
				if ($ignorecase) $case = "i"; else $case="";

				// The following expression comes from an older 
				// auto link plugin by Sean Hickey. It fixed the autolinking inside a link
				// problem. Thanks to [Steph] for the code. 
					
				
    			//$regEx = '\'(?!((<.*?)|(<a.*?)))(\b'. $keyword . '\b)(?!(([^<>]*?)>)|([^>]*?</a>))\'s' . $case;
    			$regEx = '\'(?!((<.*?)|(<a.*?)))('. $keyword . ')(?!(([^<>]*?)>)|([^>]*?</a>))\'s' . $case;
				$content = preg_replace($regEx,$url,$content,$limit);		 	   
		 }	
		
	return $content; 
}

 /* Tie the module into Wordpress */
add_action('admin_menu','bm_keywordlink_admininit');
add_filter('the_content','bm_keywordlink_replace',10);




?>
